#! /opt/bin/dash
#
# os/prog/disk/post.sh

# uses non-standard -d,--dups option to avoid consecutive duplicate block requests

export PATH="/opt/bin:/bin:/usr/bin"

echo "Content-type: text/html\n\n<html><head><title>disk</title></head><body>"
user=`echo "${REMOTE_USER}" | tr -dc '[:alnum:]' | tr '[:upper:]' '[:lower:]'`
if [ -z "$user" ]; then echo "Bad user: ${REMOTE_USER} -&gt; $user"; exit 1; fi
if [ -n "$HTTP_HOST" ]; then cd /os/prog/disk || exit 1; fi

# tomato = #FF6347
# lightgreen = #90EE90
#
in=$(cat | egrep -v '#FF6347|#90EE90')
h=$(echo "$in" | awk '{ if( $2 == "P") { print $3; exit; }}')
useed=$(echo "$in" | awk '{ if( $2 == "useed") { gsub(/[^0-9]/,"",$3); print $3; exit; }}')

#echo "<pre>$in\n</pre>"
#exit

n="6"; A="$n,-1,0"; R="2"; S="2"; o="1"; z="60,60,60"

case "$h" in
 "SATF") p="SATF"; s="123456789";;
      *) p="FIFO"; s="123456789";;
esac

if [ -n "$useed" ]; then
  seed="$useed"
  msg="- seed = $seed"
else
  x=$(perl -e "print unpack(\"C*\",$user);"); seed="${s}${x}"
  #echo "<pre>s = $s, x = $x, seed = $seed</pre>"
  msg=""
fi

echo "<b>$user</b> - disk results $msg<p>
<table border=0><tr><td bgcolor=\"#90EE90\">green = correct</td></tr>
<tr><td bgcolor=\"#FF6347\"> &nbsp; &nbsp; red = wrong</td></tr></table><p>
Policy = <b>$p</b><p>"

#echo "<pre>"
#python3 ./disk.py -d -s "$seed" -p "$p" -A "$A" -R "$R" -S "$S" -o "$o" -z "$z" -c
#echo "</pre>"

out=$(
(echo "$in"; python3 ./disk.py -d -s "$seed" -p "$p" -A "$A" -R "$R" -S "$S" -o "$o" -z "$z" -c) |
  awk 'BEGIN { v=0; print "<table border=1><tr><th align=center>Block</th>";
   print "<th align=center>Seek</th><th align=center>Rotate</th></tr>";
  } {
   # each line of user input from disk-post looks like: U name value
   if( $1 != "") { if( $1 == "U") u[$2]=$3; else if( $1 == "Block:") { gsub(":  *",":",$0);
    split($1,t,":"); b=t[2]; split($2,t,":"); s=t[2]; split($3,t,":"); r=t[2]; 
    x=u["v"v"b"]; if( x != "" && x == b) color="#90EE90"; else color="#FF6347";
    print "<tr><td align=right bgcolor=\""color"\"> "x" &nbsp; </td>";
    x=u["v"v"s"]; if( x != "" && x == s) color="#90EE90"; else color="#FF6347";
    print "<td align=right bgcolor=\""color"\"> "x" &nbsp; </td>";
    x=u["v"v"r"]; if( x != "" && x == r) color="#90EE90"; else color="#FF6347";
    print "<td align=right bgcolor=\""color"\"> "x" &nbsp; </td>";
   print "</tr>"; ++v;
 }}}'
)

if [ -z "$useed" ]; then
  bad=$(echo "$out" | grep "#FF6347" | wc -l)
  good=$(echo "$out" | grep "#90EE90" | wc -l)
  log=$(echo "$in" | tr -dc '[:alnum:]')
  echo "$(date) $user ${p}: good $good bad $bad in: $log" >> log
fi

echo "$out</table></body></html>"
