#! /opt/bin/dash
#
# os/prog/paging-linear-translate/post.sh

export PATH="/opt/bin:/bin:/usr/bin"

#echo "Content-type: text/plain\n"; in=$(cat); echo "in = \"$in\""; exit

echo "Content-type: text/html\n\n<html><head><title>paging-linear-translate</title></head><body>"
user=`echo "${REMOTE_USER}" | tr -dc '[:alnum:]' | tr '[:upper:]' '[:lower:]'`
if [ -z "$user" ]; then echo "Bad user: ${REMOTE_USER} -&gt; $user"; exit 1; fi
if [ -n "$HTTP_HOST" ]; then cd /os/prog/paging-linear-translate || exit 1; fi

# tomato = #FF6347
# lightgreen = #90EE90
#
in=$(cat | egrep -v '#FF6347|#90EE90')
useed=$(echo "$in" | awk '{ if( $2 == "useed") { gsub(/[^0-9]/,"",$3); print $3; exit; }}')

#echo "<pre>$in\n</pre>"
#exit

n="10"; a="1m"; p="64m"; P="64k"; u="70"; s="123456789"

if [ -n "$useed" ]; then
  seed="$useed"
  msg="- seed = $seed"
else
  x=$(perl -e "print unpack(\"C*\",$user);"); seed="${s}${x}"
  #echo "<pre>s = $s, x = $x, seed = $seed</pre>"
  msg=""
fi

echo "<b>$user</b> - paging-linear-translate results $msg<p>
<table border=0><tr><td bgcolor=\"#90EE90\">green = correct</td></tr>
<tr><td bgcolor=\"#FF6347\"> &nbsp; &nbsp; red = wrong</td></tr></table><p>"

#echo "<pre>"
#python3 ./paging-linear-translate.py -s "$seed" -n "$n" -P "$P" -p "$p" -a "$a" -u "$u" -v -c
# sed -e 's/) / /' -e 's/)$//'
#echo "</pre>"

out=$(
(echo "$in"; python3 ./paging-linear-translate.py -s "$seed" -n "$n" -P "$P" -p "$p" -a "$a" -u "$u" -v -c) |
 awk 'function hex(h) { if( index(h,"0x") == 1) h=substr(h,3); # remove leading 0x
  while(length(h)>8 && index(h,"0") == 1) h=substr(h,2); # remove excess leading zeros
  while(length(h)<8) h = "0"h; return "0x"h; } # add leading zeros to make length 8
  BEGIN { v=0; print "<table border=1><tr><th align=center> &nbsp; # &nbsp;</th>";
   print "<th align=center>VA</th><th align=center>PA</th></tr>"; } {
   # each line of user input from paging-linear-translate-post looks like: U name value
   if( $1 != "") { if( $1 == "U") u[$2]=$3; else if( $1 == "VA") {
    va=$2; pa=$6; if( pa == "Invalid") pa="0x00000000"; else pa=hex(pa);
    print "<tr><td align=center>"v"</td><td align=right> &nbsp; "va"</td>";
    x=u["v"v"v"]; if( x != "" && hex(x) == pa) color="#90EE90"; else color="#FF6347";
    print "<td align=right bgcolor=\""color"\"> &nbsp; "x"</td></tr>"; ++v;
 }}}'
)

if [ -z "$useed" ]; then
  bad=$(echo "$out" | grep "#FF6347" | wc -l)
  good=$(echo "$out" | grep "#90EE90" | wc -l)
  log=$(echo "$in" | tr -dc '[:alnum:]')
  echo "$(date) $user good $good bad $bad in: $log" >> log
fi

echo "$out</table></body></html>"
