#! /opt/bin/dash
#
# os/prog/paging-policy/post.sh

export PATH="/opt/bin:/bin:/usr/bin"

echo "Content-type: text/html\n\n<html><head><title>paging-policy</title></head><body>"
user=`echo "${REMOTE_USER}" | tr -dc '[:alnum:]' | tr '[:upper:]' '[:lower:]'`
if [ -z "$user" ]; then echo "Bad user: ${REMOTE_USER} -&gt; $user"; exit 1; fi
if [ -n "$HTTP_HOST" ]; then cd /os/prog/paging-policy || exit 1; fi

# tomato = #FF6347
# lightgreen = #90EE90
#
in=$(cat | egrep -v '#FF6347|#90EE90');
h=$(echo "$in" | awk '{ if( $2 == "P") { print $3; exit; }}')
useed=$(echo "$in" | awk '{ if( $2 == "useed") { gsub(/[^0-9]/,"",$3); print $3; exit; }}')

#echo "<pre>$in\n</pre>"
#exit

n="15"; m="6"

case "$h" in
 "LRU") p="LRU";  s="123456789";;
     *) p="FIFO"; s="123456789";;
esac

if [ -n "$useed" ]; then
  seed="$useed"
  msg="- seed = $seed"
else
  x=$(perl -e "print unpack(\"C*\",$user);"); seed="${s}${x}"
  #echo "<pre>s = $s, x = $x, seed = $seed</pre>"
  msg=""
fi

echo "<b>$user</b> - paging-policy results $msg<p>
<table border=0><tr><td bgcolor=\"#90EE90\">green = correct</td></tr>
<tr><td bgcolor=\"#FF6347\"> &nbsp; &nbsp; red = wrong</td></tr></table><p>
Policy = <b>$p</b><p>"

#echo "<pre>"
#python3 ./paging-policy.py -s "$seed" -n "$n" -P "$P" -p "$p" -a "$a" -u "$u" -v -c
# sed -e 's/) / /' -e 's/)$//'
#echo "</pre>"

out=$(
(echo "$in"; python3 ./paging-policy.py -s "$seed" -p "$p" -n "$n" -m "$m" -c |
  sed -e 's/FirstIn ->//' -e 's/LRU ->//' -e 's/<-.*//') |
  awk -v "m=$m" 'BEGIN { v=0;
   print "<table border=1><tr><th align=center>Time</th><th align=center>Access</th>";
   print "<th align=center>Hit or Miss</th><th align=center>Cache (after access)</th></tr>";
  } {
   # each line of user input from paging-policy-post looks like: U name value
   if( $1 != "") { if( $1 == "U") u[$2]=$3; else if( $1 == "Access:") {
   a=$2; h=$3; print "<tr><td align=center>"v"</td><td align=center>"a"</td>";
    x=u["h"v"h"]; if( x != "" && x == h) color="#90EE90"; else color="#FF6347";
    print "<td align=center bgcolor=\""color"\"> &nbsp; "x"</td>";
    for(i=4;i<=NF;++i) { gsub(/[^[:digit:]]/,"",$i); c["c"v"j"$i"j"]=$i; }
    color="#90EE90"; for(j=0;j<m;++j) { i="c"v"j"j"j";
     # avoid 0 matching ""
     if( (u[i] != "" && c[i] == "") || u[i] != c[i]) { color="#FF6347"; break; } }
    print "<td align=left bgcolor=\""color"\"> &nbsp; &nbsp; ";
    for(j=0;j<m;++j) { x=u["c"v"j"j"j"]; if(x!="") printf("%s, ",x); }
   print "</td></tr>"; ++v;
 }}}'
)

if [ -z "$useed" ]; then
  bad=$(echo "$out" | grep "#FF6347" | wc -l)
  good=$(echo "$out" | grep "#90EE90" | wc -l)
  log=$(echo "$in" | tr -dc '[:alnum:]')
  echo "$(date) $user ${p}: good $good bad $bad in: $log" >> log
fi

echo "$out</table></body></html>"
