#! /opt/bin/dash
#
# os/prog/scheduler/post.sh

export PATH="/opt/bin:/bin:/usr/bin"

h="SJF"; REMOTE_USER="guest" # public version

echo "Content-type: text/html\n\n<html><head><title>scheduler</title></head><body>"
user=`echo "${REMOTE_USER}" | tr -dc '[:alnum:]' | tr '[:upper:]' '[:lower:]'`
if [ -z "$user" ]; then echo "Bad user: ${REMOTE_USER} -&gt; $user"; exit 1; fi
if [ -n "$HTTP_HOST" ]; then cd /os/prog/scheduler || exit 1; fi

# tomato = #FF6347
# lightgreen = #90EE90
#
in=$(cat | egrep -v '#FF6347|#90EE90')

#--h=$(echo "$in" | awk '{ if( $2 == "P") { print $3; exit; }}')
useed=$(echo "$in" | awk '{ if( $2 == "useed") { gsub(/[^0-9]/,"",$3); print $3; exit; }}')

q="4"; j="5"; m="15"; s="916444529"

case "$h" in
   RR) p="RR";;
  SJF) p="SJF";;
    *) p="FIFO";;
esac

if [ -n "$useed" ]; then
  seed="$useed"
  msg="- seed = $seed"
else
  x=$(perl -e "print unpack(\"C*\",$user);"); seed="${s}${x}"
  #echo "<pre>s = $s, x = $x, seed = $seed</pre>"
  msg=""
fi

echo "<b>$user</b> - scheduler results $msg<p>Policy <b>$p</b><p>
<table border=0><tr><td bgcolor=\"#90EE90\">green = correct</td></tr>
<tr><td bgcolor=\"#FF6347\"> &nbsp; &nbsp; red = wrong</td></tr></table><p>"

#--out=$(
(echo "$in"; python3 ./scheduler.py -s "$seed" -q "$q" -j "$j" -m "$m" -p "$p" -c | grep '^  \[ time') |
 awk 'BEGIN { n=0; print "<table border=1><tr><th align=left>Time</th>\
 <th align=left>Job #</th><th align=left>Run Time</th></tr>"; } {
   # each line of user input from schedule-post looks like: U name val
   # each line of input from ./scheduler.py looks like: [ time 0 ] Run job 0 for 2.00 secs
   if( $1 != "") { if( $1 == "U") u[$2]=$3; else { ++n; t=$3; j=$7; r=int($9);
      a=u["T"n"T"]; if( a != "" && a == t) color="#90EE90"; else color="#FF6347";
       print "<tr><td align=left bgcolor=\""color"\">&nbsp;"a"</td>";
      a=u["j"n"j"]; if( a != "" && a == j) color="#90EE90"; else color="#FF6347";
       print "<td align=left bgcolor=\""color"\">&nbsp;"a"</td>";
      a=u["r"n"r"]; if( a != "" && a == r) color="#90EE90"; else color="#FF6347";
       print "<td align=left bgcolor=\""color"\">&nbsp;"a"</td></tr>";
   }}
 } END { print "</table>";
}'
#--)
#--
#--bad=$(echo "$out" | grep "#FF6347" | wc -l)
#--good=$(echo "$out" | grep "#90EE90" | wc -l)
#--log=$(echo "$in" | tr -dc '[:alnum:]')
#--
#--echo "$(date) $user ${p}: good $good bad $bad in: $log" >> log
#--
#--echo "$out\n</body></html>"

echo "</body></html>"
